dofile(ModPath.."Hooks/setup.lua")

local function Filter(tb)
	local filtered = {}
	local duplicates = {}
	for _, item in pairs(tb) do
		if not duplicates[item] then
			table.insert(filtered, item)
			duplicates[item] = true
		end
	end
	return filtered
end

function MoreIXP:AddLocStrings(list)
	Hooks:Add("LocalizationManagerPostInit", "moreixp_loc", function(loc)		
		local localized_list = {}
		local filtered_list = Filter(list)
		
		for i, item in pairs(filtered_list) do
			local shit = loc:text(item).."\n\nBONUS:\nExperience gained is increased by ##$xpboost%##."
			localized_list[item] = shit
		end
	
		LocalizationManager:add_localized_strings(localized_list)
	end)
end

function MoreIXP:Main(self)
	local current_max_rank = 0
	local base_infamy = 25
	local max_rank = 500
	local xp_bonus = 1.0
	local xp_string = "0%"
	local custom_boost_list = {}
	
	local infamy_plus_xp_item = {
		name_id = "menu_infamy_name_xp",
		add_tier = false,
		desc_id = "menu_infamy_desc_xp",
		desc_params = { xpboost = "10%" },
		icon_xy = { 1, 1 },
		cost = self.cost.tier1,
		upgrades = { infamous_xp = 1.10 },
	}

	local bonuses = MoreIXP.data[MoreIXP._settings.mode].base
	local special_bonuses = MoreIXP.data[MoreIXP._settings.mode].special

	local tier = 1
	local tier_data = bonuses[1]

	local function check_bonuses(lvl)
		if lvl > tier_data.maxlvl then
			if bonuses[tier+1] then
				tier = tier + 1
				tier_data = bonuses[tier]
				check_bonuses(lvl)
			end
		end
	end

	-- insert placeholder bonuses
	for _id, i in pairs(self.tree) do
		if not MoreIXP.add_data.firstrun then
			MoreIXP.add_data.vanilla_max = MoreIXP.add_data.vanilla_max + 1
			if _id <= base_infamy then 
				MoreIXP.base_infamy_data[i] = { desc = self.items[i].desc_params.xpboost, xp = self.items[i].upgrades.infamous_xp }
			end
		end
		if MoreIXP._settings.skipBaseInfamy and _id <= base_infamy then
			self.items[i].desc_params.xpboost = MoreIXP.base_infamy_data[i].desc
			self.items[i].upgrades.infamous_xp = MoreIXP.base_infamy_data[i].xp
		else
			if self.items[i] and self.items[i].desc_params then self.items[i].desc_params.xpboost = xp_string else self.items[i].desc_params = { xpboost = xp_string } end
			if self.items[i] and self.items[i].upgrades then self.items[i].upgrades.infamous_xp = xp_bonus else self.items[i].upgrades = { infamous_xp = xp_bonus } end
		end
		if _id > base_infamy and current_max_rank + 1 < max_rank then table.insert(custom_boost_list, self.items[i].desc_id) end
		current_max_rank = current_max_rank + 1
	end

	-- add more levels
	if current_max_rank+1 < max_rank then
		for i = current_max_rank+1, max_rank do
			table.insert(self.tree, "infamy_plus_item_"..i)
			self.items["infamy_plus_item_"..i] = deep_clone(infamy_plus_xp_item)
		end
	end
	
	-- replace placeholders with the right bonuses
	for key_tree, val_tree in pairs(self.tree) do
		if MoreIXP._settings.skipBaseInfamy and key_tree <= base_infamy then goto skipped_base_infamy end

		check_bonuses(key_tree)

		xp_bonus = tier_data.xp
		xp_string = tier_data.string
		
		for key_special, val_special in pairs(special_bonuses) do	
			if key_tree % val_special.lvl == 0 then
				xp_bonus = (xp_bonus-1)*val_special.multiplier+1
				break
			end	
		end

		xp_string = string.format("%.1f", (xp_bonus-1)*100):gsub("%.?0+$", "").."%"

		if(key_tree > base_infamy and key_tree <= MoreIXP.add_data.vanilla_max) then
			xp_string = xp_string:gsub("%%", "")
		end

		self.items[val_tree].desc_params.xpboost = xp_string
		self.items[val_tree].upgrades.infamous_xp = xp_bonus

		::skipped_base_infamy::
	end

	if #custom_boost_list > 0 then MoreIXP:AddLocStrings(custom_boost_list) end
	if MoreIXP.add_data.firstrun == false then MoreIXP.add_data.firstrun = true end
end

Hooks:PostHook(InfamyTweakData, "init", "moreixp_itd_newinit", function(self, tweak_data)
	MoreIXP:Main(self)
end)