if _G.MoreIXP then return end

_G.MoreIXP = _G.MoreIXP or {}
MoreIXP._menu_path = ModPath .. "Menu/"
MoreIXP._settings_path = SavePath .. "more_infamy_xp_settings.txt"
MoreIXP._settings = {
  showCards = true,
  skipBaseInfamy = false,
  mode = 1,
}
MoreIXP.data = {
  {
    base = {
      { xp = 1.100, maxlvl = 20, string = "10%" },
      { xp = 1.050, maxlvl = 25, string = "5%" },
      { xp = 1.020, maxlvl = 500, string = "2%" },
    },
    special = {}
  },
  {
    base = {
      { xp = 1.100, maxlvl = 8, string = "10%" },
      { xp = 1.050, maxlvl = 25, string = "5%" },
      { xp = 1.005, maxlvl = 76, string = "0.5%" },
      { xp = 1.010, maxlvl = 300, string = "1%" },
      { xp = 1.015, maxlvl = 500, string = "1.5%" }
    },
    special = {
      { multiplier = 10, lvl = 50 },
      { multiplier = 5, lvl = 25 },
      { multiplier = 3, lvl = 10 },
      { multiplier = 2, lvl = 5 },
    }
  }
}
MoreIXP.base_infamy_data = {}
MoreIXP.add_data = { vanilla_max = 0, firstrun = false }


function MoreIXP:Save()
	local file = io.open( self._settings_path, "w+" )
	if file then
		file:write( json.encode( self._settings ) )
		file:close()
	end
end

function MoreIXP:Load()
	local file = io.open( self._settings_path, "r" )
	if file then
		self._settings = json.decode( file:read("*all") )
		file:close()
	end
end

MoreIXP:Load()

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_MoreIXP", function( loc )
	loc:load_localization_file( MoreIXP._menu_path .. "en.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_MoreIXP", function( menu_manager )

	MenuCallbackHandler.MoreIXPShowCards = function(self, item)
		MoreIXP._settings.showCards = (item:value() == "on" and true or false)
		MoreIXP:Save()
	end

	MenuCallbackHandler.MoreIXPVanilla25 = function(self, item)
		MoreIXP._settings.skipBaseInfamy = (item:value() == "on" and true or false)
		MoreIXP:Save()
		MoreIXP:Main(tweak_data.infamy)
	end

	MenuCallbackHandler.MoreIXPModeChange = function(self, item)
		MoreIXP._settings.mode = item:value()
		MoreIXP:Save()
		MoreIXP:Main(tweak_data.infamy)
	end

	MoreIXP:Load()
	MenuHelper:LoadFromJsonFile( MoreIXP._menu_path .. "options.txt", MoreIXP, MoreIXP._settings )

end)